package cmdUser

import (
	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/client/utils"
	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"
)

type Unlock struct {
	Name string
}

func (cmd *Unlock) GetName() string {
	return cmd.Name
}

func (cmd *Unlock) GetDesc() []string {
	return []string{
		"Unlocks one or more users.",
		"Requires USER_UNLOCK user capability."}
}

func (cmd *Unlock) PrintUsage() {
	for _, desc := range cmd.GetDesc() {
		u.PrintlnErr(desc)
	}
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("USAGE: " + cmd.GetName() + " email [email ...]")
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
}

func (cmd *Unlock) Run(client *nc.NexusClient, args []string) int {
	argc := len(args)
	if argc < 1 {
		cmd.PrintUsage()
		return 1
	}

	// Iterates through each user (email) and unlock them
	for i := range args {
		email := args[i]
		if err := client.UserUnlock(email); err != nil {
			u.PrintlnErr(err)
			return 1
		} else {
			u.Println("Successfully unlocked user " + email)
		}
	}

	return 0
}
